
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the IVSDRAWER_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// IVSDRAWER_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.

#if  !defined(IVS_DRAWER_H)
#define IVS_DRAWER_H

#define IVSDRAWER_API

/*MACOS*/
#if defined(MAC)
#define DRAW_GL
#define CALLMETHOD 
#define WCHAR			wchar_t
#define IVS_BOOL        int

enum
{
	DRAW_PEN_DEFAULT = -1,
	DRAW_PEN_SOLID,
	DRAW_PEN_DASH,
};

typedef struct __IVS_MAC_WND
{
	int nWidth;
	int nHeight;
}IVS_WND;

/*WINDOWS*/
#elif defined(WIN32) || defined(WIN64)
#include <windows.h>

#define CALLMETHOD __stdcall
#define IVS_BOOL		BOOL

#define DRAW_PEN_SOLID            PS_SOLID
#define DRAW_PEN_DASH             PS_DASH       /* -------  */
#define DRAW_PEN_DOT              PS_DOT       /* .......  */
#define DRAW_PEN_DASHDOT          PS_DASHDOT       /* _._._._  */
#define DRAW_PEN_DASHDOTDOT       PS_DASHDOTDOT      /* _.._.._  */
#define DRAW_PEN_NULL             PS_NULL
#define DRAW_PEN_INSIDEFRAME      PS_INSIDEFRAME
#define DRAW_PEN_USERSTYLE        PS_USERSTYLE
#define DRAW_PEN_ALTERNATE        PS_ALTERNATE
#define DRAW_PEN_DEFAULT		  0xffffffff

/*LINUX*/
#elif defined(LINUX) || defined(__native_client__)
//#include <X11/X11.h>		
//#define CALLMETHOD 
#define DRAW_GL
#define CALLMETHOD 
#define WCHAR			wchar_t
#define IVS_BOOL        int

enum
{
	DRAW_PEN_DEFAULT = -1,
		DRAW_PEN_SOLID,
		DRAW_PEN_DASH,
};
#endif // MAC WIN32 LINUX		

/*Opengl ʾģʽDRAW_GL*/
#if defined(DRAW_GL)
#define IVS_DC_REF      void*
#define IVS_WND_REF     void*

typedef struct __IVS_COLOR
{
    float cgred;
    float cggreen;
    float cgblue;
}IVS_COLOR, *IVS_COLOR_REF;

typedef struct __IVSPOINT
{
	float x;
	float y;
}IVSPOINT;

typedef struct __IVS_RECT
{
    float left;
    float bottom;
    float right;
    float top;
}IVS_RECT;

#else
#define IVS_COLOR		COLORREF
#define IVS_WND_REF 	HWND
#define IVS_DC_REF		HDC
#define IVS_RECT		RECT
typedef POINT			IVSPOINT;
#endif // DRAW_GL


#include "dhnetsdk.h"
#include <time.h>

#define IVS_DATA_DEFAULT		0xffffffff
#define IVS_MAX_EVENT_NUM 32
#define IVS_MAX_TTL				0xff
#define IVS_MAX_POLYLINE_NUM	32

enum
{
	SHOW_NONE = 0,
	SHOW_RULE = (1 << 0),
	SHOW_ALARM = (1 << 1),
	SHOW_TRACK = (1 << 2),
	SHOW_ALL = (SHOW_RULE | SHOW_ALARM | SHOW_TRACK),
};

enum{
	DRAW_JSON = 0,
	DRAW_TRACK,
	DRAW_ALARM,
	DRAW_RULE,
	DRAW_MOVE_CHECK = 7,		//Zhoujj 2013.11.19
	DATA_TEST = 9,				//Zhoujj 2014.02.15
	DATA_FLOW_INFO = 13,		//Zhoujj 2014.01.23
	DRAW_END = 20
};

enum
{
	IVS_LINGER = 0,				//int 
	IVS_TRACKTAIL,				//켣β
	IVS_GET_OBJECT,
	IVS_DISABLE_VIDEO_TIME,		//ֹƵŨʱ INT ĬϿ
	IVS_DISABLE_VIDEO_OBJECT,
	IVS_MODIFY_OBJECT_RGB,		//Dword
	IVS_TRACK_OBJECT,
	IVS_SET_PEN_HEIGHT,
	IVS_SET_FONT_SIZE,
	IVS_SET_FONT_TYPE,
	IVS_SET_FONT_COLOR
};

#define IVS_MAX_ACTION_NUM	4
#define MAX_OBJECT_NUM		16
#define MAX_RULE_NUM		32
#define IVS_NAME_NUM		128

typedef struct IVS_CONFIG_EVENT
{
	char					szEventName[IVS_NAME_NUM];			// ¼,"¼б"
	char					szRuleName[IVS_NAME_NUM];			// ,ͬ
	DH_MSG_OBJECT			stuObject;
	char					Context[28];
	int						alarmAction;					//netsdkһ
	int						alarmType;
	
} IVS_CONFIG_EVENT_INFO;

typedef struct IVS_CONFIG_EVENTEX
{
	char					szEventName[IVS_NAME_NUM];			// ¼,"¼б"
	char					szRuleName[IVS_NAME_NUM];			// ,ͬ
	char					Context[28];					
	int						alarmAction;					//netsdkһ				
	int						alarmType;
	int						nObjectNum;
	DH_MSG_OBJECT			stuObject[MAX_OBJECT_NUM];						// ⵽
	int						nContext; // ֶδãΪֶ
	void*					pContext;
} IVS_CONFIG_EVENT_INFOEX;

typedef struct 
{
	int						nEventsNum;								// Ƶ
	IVS_CONFIG_EVENT_INFO	stuEventInfo[IVS_MAX_EVENT_NUM]; //¼Ϣ
	
} IVS_CFG_ANALYSEVENTS_INFO;

typedef struct 
{
	int						nEventsNum;								// Ƶ
	IVS_CONFIG_EVENT_INFOEX stuEventInfo[IVS_MAX_EVENT_NUM]; //¼Ϣ
	
} IVS_CFG_ANALYSEVENTS_INFOEX;

typedef struct
{
	int						nX; //0~8191
	int						nY;		
} IVS_CFG_POLYLINE;

typedef struct  __IVS_WEB_RULE
{
	int						size;
	int						nRuleType;
	int						nRuleEnable;
	int						ndirect1;
	int						ndirect2;
	int						nPoint1;
	int						nPoint2;
	unsigned char			bActionType[4];
	DH_MSG_OBJECT			objectMsg;
	char					szRuleName[IVS_NAME_NUM];
	IVS_CFG_POLYLINE		stuDetectLine1[IVS_MAX_POLYLINE_NUM];
	IVS_CFG_POLYLINE		stuDetectLine2[IVS_MAX_POLYLINE_NUM];
	char					szRevered[256];
}IVS_WEB_RULE;

typedef struct __IVS_WEB_RULE_ARRAY
{
	int						size;
	int						nCount;
	IVS_WEB_RULE*			pRule;
}IVS_WEB_RULE_ARRAY;

typedef struct
{
	int						objectid;
	struct tm				startTime;
	struct tm				endTime;
	INT64				nBeginFileOffset;				// ʼʱļƫ, λ: ֽڣ忪ʼʱƵ֡ԭʼƵļļʼƫƣ
	INT64				nEndFileOffset;					// ʱļƫ, λ: ֽڣʱƵ֡ԭʼƵļļʼƫƣ
	int						classid;
}IVSOBJECT;


typedef struct
{
	IVS_BOOL trackex2objtype;  //Ƿʾͣ0:,1:ʾ.Ĭϲʾ
    IVS_BOOL trackex2attribute88;//Ƿʾ88԰0:,1:ʾ.Ĭʾ
    
}TrackEx2Configure;

union ObjectContex
{
	IVSOBJECT				object;
	IVSPOINT				xPt;
	char					szReverd[128];
};

typedef struct _DH_IVS_POINT
{
	short 		x; 
	short 		y; 
	short		xSize;
	short		ySize;
	//켣ӾεģXYXSizeYSizeӾ꣨lefttoprightbottom
	//RECT=(X-XSize, Y-YSize, X+XSize, Y+YSize)
	
}DH_IVS_POINT; 

typedef struct  _RuleColor
{
	int ruletype;
	IVS_COLOR crColor;
		
}RuleColor;

#ifdef __cplusplus
extern "C" {
#endif

/********************************************************************
*	Funcname: 	    	DRAW_Startup
*	Purpose:			IVSDraw(ֻһ)
*   InputParam:         void
*   OutputParam:        void
*   Return:             int:  0 Ϊɹ, !0 Ϊʧ 
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
*********************************************************************/
IVSDRAWER_API int CALLMETHOD DRAW_Startup();
/********************************************************************
*	Funcname: 	    	DRAW_Cleanup
*	Purpose:			˳IVSDraw
*   InputParam:         void
*   OutputParam:        void
*   Return:             void 
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
*********************************************************************/

IVSDRAWER_API void CALLMETHOD DRAW_Cleanup();

/********************************************************************
*	Funcname: 	    	DRAW_Open
*	Purpose:			ͼ˿
*   InputParam:         int nPort: ͼ˿
*   OutputParam:        void
*   Return:             BOOL,ɹTRUE,ʧܷFALSE. 
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
*********************************************************************/
IVSDRAWER_API BOOL CALLMETHOD DRAW_Open(int nPort);

/********************************************************************
*	Funcname: 	    	DRAW_Close
*	Purpose:			رͼ˿
*   InputParam:         int nPort: ͼ˿
*   OutputParam:        void
*   Return:             void
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
*********************************************************************/
IVSDRAWER_API void CALLMETHOD DRAW_Close(int nPort);

/*********************************************************************
*	Funcname: 			DRAW_Reset	
*	Purpose:			ͼ˿
*   InputParam:         nPort,ͼ˿: ntype,
*   OutputParam:        void
*   Return:             BOOL,ɹTRUE,ʧܷFALSE. 
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
**********************************************************************/
IVSDRAWER_API BOOL CALLMETHOD DRAW_Reset(int nPort,int type);

/**********************************************************************
*	Funcname: 			DRAW_InputJsonData    	
*	Purpose:			ַ
*   InputParam:         nPort:˿ں(Range)
*						pJsonData:ַڴַ
*						nDataLen:ݳ
*						nFrame: ֡
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
***********************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_InputJsonData(int nPort, unsigned char* pJsonData, int nDataLen,int nFrame);

/**********************************************************************
*	Funcname: 	        DRAW_SetRuleColor		    	
*	Purpose:			ùɫ
*   InputParam:         nRuleColor:ƺ͹ɫ
*						nRuleNum:
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2016:09:13  
*   Revision Record:    2016/9/13:wangguojian:modify......
***********************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_SetRuleColor(int nPort,RuleColor* nRuleColor, int nRuleNum);

/***********************************************************************
*	Funcname: 			DRAW_InputRuleData	
*	Purpose:			
*   InputParam:         nPort:˿ں(Range)
*						pRuleData:ڴַ
*						nframe:֡
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_InputRuleData(int nPort, int nType, unsigned char* pRuleData, int nframe);

/************************************************************************
*	Funcname: 	    	DRAW_InputTrackData
*	Purpose:			켣
*   InputParam:         nPort:˿ں
*						pTrackData:ֹ켣ڴַ
*						nDataLen:ݳ
*						nFrameNum: ֡
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
*************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_InputTrackData(int nPort, int nType, unsigned char* pTrackData, int nDataLen,int nFrameNum);
IVSDRAWER_API int  CALLMETHOD DRAW_InputTrackDataEx2(int nPort, int nType, unsigned char* pTrackData, int nDataLen,int nFrameNum);

/*************************************************************************
*	Funcname: 	    	DRAW_InputAlarmData
*	Purpose:			뾯
*   InputParam:         nPort:˿ں
*						pJsonData:ڴַ
*						nDataLen:ݳ
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
***************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_InputAlarmData(int nPort, int nType, unsigned char* pAlarmData, int nDataLen);

/***************************************************************************
*	Funcname: 	    	DRAW_InputAlarmDataEx
*	Purpose:			뾯
*   InputParam:         nPort:˿ں
*						pJsonData:ڴַ
*						nDataLen:ݳ
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:20  
*   Revision Record:    2012/12/20:YeYamin:modify......
****************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_InputAlarmDataEx(int nPort, int nType, unsigned char* pAlarmData, int nDataLen);

/***************************************************************************
*	Funcname: 	    	DRAW_InputMoveCheckData
*	Purpose:			붯Ϣ
*   InputParam:         nPort:˿ں
*						nType:
*						pData:Ϣ
*						nDataLen:ݳ
*						nFrameNum:֡
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2013/09/23  
*   Revision Record:    2013/09/23:Zhoujj:modify......
****************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_InputMoveCheckData(int nPort, int nType, unsigned char* pData, int nDataLen, int nFrameNum);

/***************************************************************************

*	Funcname: 	    	DRAW_InputTextData
*	Purpose:			ָλʾһַɶУ\nβ
*   InputParam:         nPort:˿ں
*						pText:Ҫʾַ
*                       nTextNumPos:ַ 
*                       hPos:ַʾλ 
*						nFontsize:С
*						red green blue:ɫ
*						nAlignMode:뷽ʽ0룬1ж룬2Ҷ
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2013/09/23  
*   Revision Record:    2013/09/23:Zhoujj:modify......
****************************************************************************/

typedef struct
{
	const char* pText;
	IVSPOINT hPos;
	int nFontsize;
	int nRed;
	int nGreen;
	int nBlue;
    int nAlignMode;
}TextData;



IVSDRAWER_API int  CALLMETHOD DRAW_InputTextData(int nPort, TextData* pTextData, int nTextNumPos);

/****************************************************************************
*	Funcname: 	    	DRAW_Draw
*	Purpose:			ִͼ
*   InputParam:         nPort:ͼ˿
*						hDC:	ͼ豸
*						hwnd:	ھ
*						Frame:	֡
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
****************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_Draw(int nPort, IVS_DC_REF hDC,IVS_WND_REF hwnd,int nFrameNum);

/****************************************************************************
*	Funcname: 			DRAW_SetLifeCount    	
*	Purpose:			ʱ
*   InputParam:         nPort: ͼ˿
*						type:	
*						nLifeCount:	ʱ
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
*****************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_SetLifeCount(int nPort, int type,int nLifeCount);

/*****************************************************************************
*	Funcname: 			DRAW_SetEnable	
*	Purpose:			ʹ
*   InputParam:         nPort: ͼ˿
*						type:	
*						bEnable:	ʹ
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
******************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_SetEnable(int nPort, int nType, IVS_BOOL bEnable);

/******************************************************************************
*	Funcname: 			DRAW_SetPen	
*	Purpose:			
*   InputParam:         nPort: ͼ˿
*						nType:	
*						nPenStyle: ʸʽʵorߣ
*						nWidth: ʿ
*						crColor: ɫ
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
*******************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_SetPen(int nPort, int nType, int nPenStyle, int nWidth, IVS_COLOR crColor);

/*******************************************************************************
*	Funcname: 			DRAW_GetLastError	
*	Purpose:			ȡĴ
*   InputParam:         nPort: ͼ˿
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
*******************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_GetLastError(int nPort);

/*******************************************************************************
*	Funcname: 			DRAW_Ioctl	
*	Purpose:			ִ
*   InputParam:         nPort: ͼ˿
*						cmdType:	
*						context: ַ
*						len: 
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
********************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_Ioctl(int nPort,int cmdType,void* context,int len);

/********************************************************************************
*	Funcname: 			DRAW_InputJpegData	
*	Purpose:			JPEG
*   InputParam:         nPort: ͼ˿
*						nType:	δʹ
*						pJpegData: JPEGڴַ
*						nDataLen: ݳ
*						nFrameNum: ֡
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
*********************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_InputJpegData(int nPort, int nType, unsigned char* pJpegData, int nDataLen,int nFrameNum);

/*********************************************************************************
*	Funcname: 			DRAW_Refresh	
*	Purpose:			ˢ֡
*   InputParam:         nPort: ͼ˿
*						nFrameNum:	֡
*   Return:             int : Ƿɹɹ0ɹ-1
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
*********************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_Refresh(int nPort,int nFrameNum);

/*********************************************************************************
*	Funcname: 			DRAW_Idle	
*	Purpose:			û
*   InputParam:         nPort: ͼ˿			
*   Return:             void
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
*********************************************************************************/
IVSDRAWER_API void CALLMETHOD DRAW_Idle(int nPort);

/*********************************************************************************
*	Funcname: 			DRAW_Clean	
*	Purpose:			ͼ
*   InputParam:         nPort: ͼ˿
*						nRevered:	Ԥ
*   Return:             void
*   Created:	        2012:12:19  
*   Revision Record:    2012/12/19:YeYamin:modify......
*********************************************************************************/
IVSDRAWER_API void CALLMETHOD DRAW_Clean(int nPort,int nRevered);

/*********************************************************************************
*	Funcname: 			DRAW_SetTime	
*	Purpose:			ù켣ʼʱ䣨ƵŨ
*   InputParam:         nPort: ͼ˿
*						nTime: ʱ
*						nObjectId: ID
*   Return:             int: ɹ0 ʧܷ -1
*   Created:	        2013:11:19  
*   Revision Record:    2013/11/19:Zhoujj:modify......
*********************************************************************************/
IVSDRAWER_API int CALLMETHOD DRAW_SetTime(int nPort,int nTime, int nObjectId);

/*********************************************************************************
*	Funcname: 			DRAW_SetShowType	
*	Purpose:			ʾͣڵrulealarmtrack
*   InputParam:         nPort: ͼ˿
*						ntype: ҪʾͣͿʹá롱"|"
*   Return:             void
*   Created:	        2014:11:17  
*   Revision Record:    2014:11:17:wj8:created......
*********************************************************************************/
IVSDRAWER_API void CALLMETHOD DRAW_SetShowType(int nPort, int ntype);

/*********************************************************************************
*	Funcname: 			DRAW_SetDrawOneTrackCallback
*	Purpose:			trackص
*   InputParam:         nPort: ͼ˿
*   Return:             void
*   Created:	        2015:04:24  
*   Revision Record:    2015:04:24:wj8:created......
*********************************************************************************/
typedef void (CALLMETHOD* OnDrawOneTrack)(int nClassID, int nObjID, DH_IVS_POINT* pPoints, int nPointNum, void* pUD);
IVSDRAWER_API void CALLMETHOD DRAW_SetDrawOneTrackCallback(int nPort, OnDrawOneTrack pCB, void* pUD);

/*********************************************************************************
*	Funcname: 			DRAW_SetRuleTrackAlarm
*	Purpose:			ɴ˹trackᱻ
*   InputParam:         nPort: ͼ˿
*						pRuleName 
*						bEnable: Ƿ
*   Return:             void
*   Created:	        2015:04:24  
*   Revision Record:    2015:04:24:wj8:created......
*********************************************************************************/
IVSDRAWER_API void CALLMETHOD DRAW_SetRuleTrackAlarm(int nPort, const char* pRuleName, bool bEnable);

/*********************************************************************************
*	Funcname: 			DRAW_SetShowTrackType
*	Purpose:			trackʾ
*   InputParam:         nPort: ͼ˿
*						type: 0ʾtrackĬϷʽ1ֻʾбtrack
*   Return:             void
*   Created:	        2015:04:24
*   Revision Record:    2015:04:24:wj8:created......
*********************************************************************************/
IVSDRAWER_API void CALLMETHOD DRAW_SetShowTrackType(int nPort, int type);

IVSDRAWER_API void CALLMETHOD DRAW_SetFrameNum(int nPort, int frameno);

/******************************************************************************
*	Funcname: 			DRAW_SetTrackObjectColor	
*	Purpose:			{ID, ID}øɫ, ״
*   InputParam:         nPort: ͼ˿
*						nClassId: id
*						nObjectId: id
*						crColor: ɫ
*						bSpecialShape:1:״, 0:ĬϾ.
*                       bSpecialSingle:1:ֻǰٿ״ٿصĬ״ 0״䡣
*   Return:             int : Ƿɹɹ0ɹ-1
*******************************************************************************/
IVSDRAWER_API int  CALLMETHOD DRAW_SetTrackObjectColor(int nPort, int nClassId, int nObjectId, IVS_COLOR crColor, bool bSpecialShape,bool bSpecialSingle);
/******************************************************************************
*	Funcname: 			DRAW_SetTrackEX2Sharp	
*	Purpose:			bSpecialShape־óʶٿ״
*   InputParam:         nPort: ͼ˿
*						bSpecialShape:1:״, 0:ĬϾ.
*   Return:             int : Ƿɹɹ0ɹ-1
*******************************************************************************/
IVSDRAWER_API int CALLMETHOD DRAW_SetTrackEX2Sharp(int nPort, bool bSpecialShape);
/******************************************************************************
*	Funcname: 			DRAW_SetTrackEx2Config	
*	Purpose:			trackex2configʾĳЩֶΣĬǲʾ
*   InputParam:         nPort: ͼ˿
*						trackex2config:ǷʾĳЩֶ
*   Return:             void
*******************************************************************************/
IVSDRAWER_API void CALLMETHOD DRAW_SetTrackEx2Config(int nPort, TrackEx2Configure trackex2config);

#ifdef NACL
IVSDRAWER_API void CALLMETHOD DRAW_SetDrawSurfaceParam(int nPort, int nx, int ny, int nwidth, int nheight);
#endif

#ifdef __cplusplus
}
#endif

#endif
